import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { Member, MemberParam } from './model';

/**
 * 分页查询会员
 */
export async function pageMembers(params: MemberParam) {
  const res = await request.get<ApiResult<PageResult<Member>>>(
    '/xm/member/page',
    { params }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询用户列表
 */
export async function listUsers(params?: MemberParam) {
  const res = await request.get<ApiResult<Member[]>>('/system/user', {
    params
  });
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询用户
 */
export async function getUser(id: number) {
  const res = await request.get<ApiResult<Member>>('/system/user/' + id);
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加用户
 */
export async function addUser(data: Member) {
  const res = await request.post<ApiResult<unknown>>('/system/user', data);
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改用户
 */
export async function updateUser(data: Member) {
  const res = await request.put<ApiResult<unknown>>('/system/user', data);
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除用户
 */
export async function removeUser(id?: number) {
  const res = await request.delete<ApiResult<unknown>>('/system/user/' + id);
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除用户
 */
export async function removeUsers(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>('/system/user/batch', {
    data
  });
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改用户状态
 */
export async function updateUserStatus(userId?: number, status?: number) {
  const res = await request.put<ApiResult<unknown>>('/system/user/status', {
    userId,
    status
  });
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
